config/routes.rb
Rails.application.routes.draw do

  devise_for :admin_users, ActiveAdmin::Devise.config
  ActiveAdmin.routes(self)
  devise_for :users

  root 'static_pages#home'

  resources :line_items do
    match :qty, action: :qty, via: [:post, :delete], on: :member #-> url.com/line_items/qty
    match :input_field_change, action: :input_field_change, via: :post, on: :member
  end
  resources :carts do
    match :empty_line_items, action: :empty_line_items, via: :delete, on: :member #-> url.com/line_items/qty
  end

  get 'navbar_cart'           => 'carts#navbar_cart'
  get 'continue_shopping'     => 'carts#continue_shopping'
  get 'search'                => 'products#product_search'
  get 'checkout'              => 'charges#checkout'
  get 'support'               => 'support_messages#new'

  resources :carts, :orders
  resources :charges
  resources :categories, only: [:show, :index]
  resources :departments, only: [:index]
  resources :products, only: [:show, :index, :new, :create]
  resources :static_pages, only: [:home, :help]
  resources :support_messages, only: [:create]

   

end

app/models/cart.rb
class Cart < ActiveRecord::Base
	has_many :line_items, dependent: :destroy

	def add_product(product_id)
		current_item = line_items.find_by(product_id: product_id)
		if current_item
		else
			current_item = line_items.build(product_id: product_id)
		end
		current_item
	end

	def total_price
		line_items.to_a.sum { |item| item.total_price }
	end

	def decrease(line_item_id)
    current_item = line_items.find(line_item_id)
    if current_item.quantity > 1
      current_item.quantity -= 1
    else
      current_item.quantity = 1
    end
    current_item
  end

  def increase(line_item_id)
    current_item = line_items.find(line_item_id)
    if current_item.quantity >= 1
      current_item.quantity += 1
    else
      current_item.quantity = 1
    end
    current_item
  end

  def input_field_change(line_item_id, quantity)
  	current_item = line_items.find(line_item_id)
    if (current_item.quantity >= 1) and (quantity.to_f >= 1)
  	 current_item.quantity = quantity.to_f
    else
      current_item.quantity = 1
    end
  	current_item
  end
  
end

app/controllers/carts_controller.rb
class CartsController < ApplicationController
  before_action :set_cart, only: [:show, :edit, :update, :destroy]
  rescue_from ActiveRecord::RecordNotFound, with: :invalid_cart

  # GET /carts
  # GET /carts.json
  def index
    @carts = Cart.all
  end

  # GET /carts/1
  # GET /carts/1.json
  def show
    #@disable_shopping_cart = true
    #current_user.cart_id = 1
    #if current_user.cart_id = params[:cart_id] 
    #  then
    #  @a = "true" else @a = "false"
   # end
  end

  def navbar_cart
    @cart = Cart.find(session[:cart_id])
    respond_to do |format|
      format.js
    end
  end

  def continue_shopping
    session[:return_to] ||= request.env['HTTP_REFERER'] || root_url
    redirect_to session.delete(:return_to)
    session[:last_product_page] = request.env['HTTP_REFERER'] || products_url
  end

  # GET /carts/new
  def new
    @cart = Cart.new
  end

  # GET /carts/1/edit
  def edit
  end

  # POST /carts
  # POST /carts.json
  def create
    @cart = Cart.new(cart_params)
    respond_to do |format|
      if @cart.save
        format.html { redirect_to @cart, notice: 'Cart was successfully created.' }
        format.json { render :show, status: :created, location: @cart }
      else
        format.html { render :new }
        format.json { render json: @cart.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /carts/1
  # PATCH/PUT /carts/1.json
  def update
    respond_to do |format|
      if @cart.update(cart_params)
        format.html { redirect_to @cart, notice: 'Cart was successfully updated.' }
        format.json { render :show, status: :ok, location: @cart }
      else
        format.html { render :edit }
        format.json { render json: @cart.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /carts/1
  # DELETE /carts/1.json
  def destroy
    @cart.destroy if @cart.id == session[:cart_id]
    session[:cart_id] = nil
    respond_to do |format|
      if @line_item.save
        format.js { @item = params[:id] }
        format.json { head :ok }
      else
        format.html { render action: "edit" }
        format.json { render json: @line_item.errors, status: :unprocessable_entity}
      end
    end
  end

  def empty_line_items
    @cart = Cart.find(session[:cart_id])
    @cart.line_items.each do |line_item|
      line_item.destroy
    end
    respond_to do |format|
      format.js { @cart = Cart.find(session[:cart_id]) }
      format.json { head :ok }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_cart
      @cart = Cart.find(session[:cart_id])
    end

    def require_permission
      if current_user.cart_id != Cart.find(params[:id]) && current_user.admin == false
        redirect_to root_path
      end
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def cart_params
      params[:cart]
    end

    def invalid_cart
      logger.error "Attempt to access invalid cart #{params[:id]}"
      redirect_to root_url, notice: 'Invalid cart'
    end   
end

app/helpers/carts_helper.rb
module CartsHelper
end

app/views/carts/_braintree.erb
<form id="checkout" method="post" action="/checkout" class="btn btn-default">
  <div id="dropin"></div>
  <input type="submit" value="Pay with paypal">
</form>

<script type="text/javascript">
  function setupBT() {
    braintree.setup("<%=@client_token%>", 'dropin', {
      container: 'dropin'
    });
  }
  if (window.addEventListener)
    window.addEventListener("load", setupBT, false);
  else if (window.attachEvent)
    window.attachEvent("onload", setupBT);
  else window.onload = setupBT;
  </script>
</script>

app/views/carts/_cart.html.erb
<% if @cart.line_items.blank? %>
	<div class="row text-center empty">
		Your cart is empty
	</div>
	<%= link_to "Browse shop", departments_path, class: "btn btn-primary btn-sm btn-block" %>
<% else %>
<div class="cart-table">
		<table class="table table-bordered table-responsive">
		 <thead>
	    <tr>
	    	<th>Image</th>
	      <th>Product title</th>
	      <th>Price</th>
	      <th>Quantity</th>
	    </tr>
	  </thead>
	  <tbody>
	  	<% @cart.line_items.each do |line_item| %>
		    <tr>
		    	<td>
		    		<%= link_to line_item.product do %> 
		    			<% cl_image_tag line_item.product.attachments.first.image, :width => 100, :crop=>"pad" %>
		    		<% end %> 
		    	</td>
		      <td >
		      	<%= link_to line_item.product.title, product_path(line_item.product) %></td>
		      <td>
		      	<% if !line_item.product.discount.nil? %>
		      		€<%= line_item.product.price - line_item.product.discount %>
		      	<% else %>
							€<%= line_item.product.price %>
						<% end %>
		      </td>
		      <td><%= line_item.quantity %></td>
		    </tr>
		   <% end %>
		   	<tr>
		   		<th></th>
		    	<th></th>
		   		<th>Total:</th>
		    	<th><b>€ <%= @cart.total_price %></b></th>
		    </tr>
	  </tbody>
	</table>
</div>
<div class="row">
	<div class="col-md-6 col-xs-6">
		<%= link_to "show cart and checkout", cart_path(session[:cart_id]),  method: :get, class: "btn btn-primary btn-lg outline" %>
	</div>
	<div class="col-md-6 col-xs-6">
		<%= button_to "empty", empty_line_items_cart_path(session[:cart_id]), remote: true, method: :delete, data: { confirm: 'Are you sure?'}, class: "btn btn-primary btn-lg outline pull-right"  if !@cart.line_items.blank? %>
	</div>
</div>
<% end %>

app/views/carts/empty_line_items.js.erb
$(document).ready(function(){
	$('#cart-badge-id').text(<%=@cart.line_items_count%>);
	$('#cart').html("<%= escape_javascript render(@cart) %>");
});

app/views/carts/navbar_cart.js.erb
$('#cart').html("<%= escape_javascript render(@cart) %>");

app/views/carts/show.html.erb
<%= stylesheet_link_tag "navbar", "carts", "products", "footer" %>
<% @title="Flybit - Cart" %>
<% if notice %>
<p id="notice"><%= notice %></p>
<% end %>
<div class="container">
	<div class="row">
		<div class="panel panel-info">
			<div class="panel-heading">
					<div class="panel-title">
						<div class="row">
							<div class="col-sm-6 col-md-6 col-xs-6">
								<h5><span class="glyphicon glyphicon-shopping-cart"></span> Shopping Cart</h5>
							</div>
							<div class="col-sm-6 col-md-6 col-xs-6">
								<%= button_to "empty", empty_line_items_cart_path(session[:cart_id]), remote: true, method: :delete, data: { confirm: 'Are you sure?'}, class: "btn btn-primary btn-lg outline pull-right"  if !@cart.line_items.blank? %>
							</div>
						</div>
					</div>
			</div>
			<div class="panel-body">
				<% if @cart.line_items.empty? %>
					<div class="row text-center">
						<h3>Your cart is empty</h3>
						<div class ="row">
							<div class="col-md-4 col-sm-4 col-xs-4">
							</div>
							<div class="col-md-4 col-sm-4 col-xs-4">
								<%= link_to "Browse shop", departments_path, class: "btn btn-primary btn-sm btn-block" %>
							</div>
							<div class="col-md-4 col-sm-4 col-xs-4">
							</div>
						</div>
						<p>Or try to refresh this page</p>
					</div>
				<% else %>
					<% @cart.line_items.each_with_index do |item, index| %>
					<!-- line item row -->
						<div class="row" id="line-item-row-id-<%= item.id %>">
							<div class="col-xs-2 col-md-2 col-sm-2">
								<%= cl_image_tag item.product.attachments.first.image, :width => 250, :crop=>"pad", class: "img-responsive" %>
								<% if !item.product.discount.blank? %>
					      <div class="ribbon"><span>-<%= number_to_percentage(item.product.discount_percent(item.product.price, item.product.discount), precision: 0) %></span></div>
					      <% end %>
							</div>
							<div class="col-xs-4 col-md-4 col-md-4">
								<h4 class="product-name"><strong><%= link_to "#{item.product.title}", product_path(item.product) %></strong></h4><h4><small><%= item.product.description %></small></h4>
							</div>
							<div class="col-md-5" id="qty-n-price-row-<%= index + 1 %>">
								<div class="col-xs-4 col-md-4 text-left">
									<h6><strong><span class="text-muted">€<%= item.product.price_with_discount(item.product.price, item.product.discount) %> </span> <span> x </span></strong></h6>
								</div>
								<div class="col-xs-4 col-md-4">
									<%= number_field_tag 'quantity', item.quantity, { min: 1, :onchange => "input_change(#{index + 1}, #{item.id})", id: "quantity-input-id-#{index + 1}" } %>
								</div>
								<div class="col-xs-4 col-md-4 text-center">
									<!-- id = litp- = line item total price -->
									<h6><strong> <span id="litp-id-<%= index %>">= €<%= item.total_price %></span></strong></h6>
								</div>
							</div>
							<div class="col-xs-1 col-md-1 col-md-1">
								<%= button_to qty_line_item_path(item), method: :post, remote: true,  params: { index: index + 1 } do%>
									<span class="glyphicon glyphicon-plus"></span>
								<% end %>
								<%= button_to qty_line_item_path(item), method: :delete, remote: true, params: { index: index + 1 } do%>
									<span class="glyphicon glyphicon-minus"></span>
								<% end %>
								<%= button_to item, method: :delete , remote: true, data: { confirm: "Are you sure?" } do %>
							    <span class="glyphicon glyphicon-trash"></span>
								<% end %>
							</div>
						</div><!-- end of line item row-->
						<hr id="line-item-hr-id-<%= item.id %>">
					<% end %>
					<div class="row">
						<div class="col-xs-10">
							<div class="row text-center">
							</div>
						</div>
						<div class="col-xs-2">
							<h4 class="text-center" id="line-items-total-sum"> <strong>Total: €<%= @cart.total_price %></strong></h4>
						</div>
					</div>
				<% end %>
			</div>
			<div class="panel-footer">
				<div class="row">
					<div class="col-md-10">
					</div>
					<div class="col-md-2">
						<%= link_to checkout_path, method: :get, class: "btn btn-primary btn-lg outline" do %>
							<i>Checkout</i>
						<% end %>
					</div>
				</div>
			</div>
		</div><!-- End of panel panel-onfo -->
	</div><!-- End of row -->
</div><!-- End of container -->
<script type="text/javascript">
  function input_change(index, item){
  	quantity = parseFloat($("#quantity-input-id-" + index).val()) || 1;
  	$.ajax({
			type: "POST",
			url: "/line_items/" + item + "/input_field_change",
			data: {index : index, quantity : quantity}
		});
  }
</script>